#include <iostream>
#include <stdlib.h>
#include <cmath>
using namespace std;

                //  Filter to create a projection onto a 
                // stroboscopic Poincare Surface of Section (SoS)
                // for the damped driven Nonlinear pendulum

                // pipe t, x, v  in this code cin
                                               // M. Vallieres
int main( int argc, char * argv[]   )
{
    double t, x, v;           // point at current time slice
    double tp, xp, vp;        // previous point on trajectory
    double tPI, xPI, vPI;     // point on SoS
    double packNo;            // packing data in each record 
    int countPTS = 0;         // No pts in phase space trajectory
    double Transient, T;      // angle between and at planes of SoS
    int pointPI;              // plane No
    double small = 0.000001;
                              // external driving term frequency
    double Omega = 0.666666;
    if ( argc > 1 )
        Omega = atof( argv[1] );
                              // Transient time
    Transient = 0;
    if ( argc > 2 )
        Transient = atof( argv[2] );

    int PrintDebug = 0;       // Print details for debuging
    if ( argc > 3 )
        PrintDebug = atoi( argv[3] );

    T = 2 * M_PI / Omega;     // time between planes of SoS --
                              // period of driving term
    cerr << " Period, Transient : " << T << " " << Transient << endl;

                              // First Plane (no transient)
    if( Transient < small ) 
      {
        pointPI = 1;          // plane number
        tPI = pointPI * T;    // time at current plane
      }       


    if ( Transient > 0.0 )    // First Plane (with transient)
      {
        pointPI = (int)( Transient/T ) ; // last plane in Transient
        pointPI++;            // First plane in displayed SoS
        tPI = pointPI * T;
      }

    if ( PrintDebug == 2 )
          cerr << " pointPI, tPI : " << pointPI 
          << " " <<  tPI << endl;

                              // first Phase Space point
    cin >> t >> x >> v >> packNo;
    if ( cin.eof() == true )  // proper file?         
      {  
        cerr << "Error in opening the file";
        return 1;
       }
    countPTS++;                 // # points
   
    if( PrintDebug == 2 )
         cerr << 1 << " " << tPI << " " 
              << x << " " << v << " " << endl;

                               // scan over fractal   
    for ( ; ; )
      {
       tp = t;
       xp = x;
       vp = v;
                              // new point
       cin >> t >> x >> v >> packNo;
       if ( cin.eof() == true ) // end of list of points ?
         {
           cerr << " End of data stream : " << 
                     countPTS << "  " << pointPI << 
                     "  " << tPI << endl;
           return 0;
         } 

                              // keep this point
       countPTS++;
                              // angle at which to project the point
       tPI = pointPI * T;
                              // project on time axis
                              // and use linear interpolation
                              // for x & v
       if ( ( tp < tPI ) && ( t > tPI ) ||
           (  tp > tPI ) && ( t < tPI )   ) 
          {
             if ( ! ( PrintDebug == 0 ) )
               {
                 cerr << "<-------->" << endl;
                 cerr << pointPI << "  Select time intervals " << endl;
                 cerr << "   " << tp << " " << tPI << " " << t << endl;
                }
             double ratio = (tPI-tp) / (t-tp);
             tPI = tp + (t-tp) * ratio;
             xPI = xp + (x-xp) * ratio;
             vPI = vp + (v-vp) * ratio;
             if( ! ( PrintDebug == 0 ) )
                { 
                   cerr << "   "  << "  Interpolate tPI " << endl; 
                   cerr << "   "  << xp << " " << xPI << " " << x << endl;
                   cerr << "   "  << vp << " " << vPI << " " << v << endl;
                }   
             cout << pointPI << " " << tPI << " ";
             cout << xPI << " " << vPI << " " << endl;

             pointPI++;
          }

     }

   cerr << " ---------->      End of data " << endl;
}


